<template>
  <div>
    <q-page>
      <div
        style="max-width: 56rem; margin: 0 auto; padding-bottom: 3rem"
        class="column items-center q-mt-xs"
      >
        <q-form
          @submit="addUserData()"
          @clear="onSubmit"
          ref="resetValidation"
          class="row q-px-lg q-gutter-x-sm"
        >
          <div class="col-12">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              {{ form.name }}'s Personal Details
            </h1>
            <div class="row q-gutter-xs">
              <q-input
                class="col-12 col-md-4"
                outlined
                dense
                v-model="form.name"
                label="Name"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-4"
                outlined
                dense
                v-model="form.username"
                label="Username"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-3"
                outlined
                dense
                v-model="form.email"
                label="Email"
                type="email"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="form.phone"
                label="Phone Number"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="form.website"
                label="Website"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <div class="col-12">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              Address
            </h1>
            <div class="row q-gutter-xs">
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="form.address.street"
                label="Street"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="form.address.suite"
                label="Suite"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="form.address.city"
                label="City"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="form.address.zipcode"
                label="ZIP Code"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <div class="col-12" style="width: 100%">
            <h1 class="text-h6 text-size-18 text-primary text-weight-bold">
              Company
            </h1>
            <div class="row q-gutter-sm">
              <q-input
                class="col-12 col-md-11"
                outlined
                dense
                v-model="form.company.name"
                label="Company Name"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-6"
                outlined
                dense
                v-model="form.company.catchPhrase"
                label="Catchphrase"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
              <q-input
                class="col-12 col-md-5"
                outlined
                dense
                v-model="form.company.bs"
                label="BS"
                lazy-rules
                :rules="[(val) => !!val || 'Please fill-in']"
              />
            </div>
          </div>
          <q-btn
            class="col-5 q-mt-lg"
            label="Add User"
            color="primary"
            type="submit"
          />
        </q-form>
      </div>
    </q-page>
  </div>
</template>

<script>
import { ref } from "vue";
import {
  addUserData,
  resetValidation,
  requiredInput,
  userFormValidation,
  btnUserFormState,
  btnLoadingState,
} from "../composables/axiosData";

let form = ref({
  id: null,
  name: null,
  username: null,
  email: null,
  address: {
    street: null,
    suite: null,
    city: null,
    zipcode: null,
    geo: {
      lat: null,
      lng: null,
    },
  },
  phone: null,
  website: null,
  company: {
    name: null,
    catchPhrase: null,
    bs: null,
  },
});

let currentForm = ref(1);
export default {
  setup() {
    return {
      resetValidation,
      form,
      currentForm,
      addUserData,
      btnUserFormState,
      btnLoadingState,
    };
  },
};

export { form };
</script>

<style>
.text-size-18 {
  font-size: 18px;
  color: white;
}
</style>
